# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['NexusBlobstoreAzureArgs', 'NexusBlobstoreAzure']

@pulumi.input_type
class NexusBlobstoreAzureArgs:
    def __init__(__self__, *,
                 bucket_configuration: pulumi.Input['NexusBlobstoreAzureBucketConfigurationArgs'],
                 name: Optional[pulumi.Input[str]] = None,
                 soft_quota: Optional[pulumi.Input['NexusBlobstoreAzureSoftQuotaArgs']] = None):
        """
        The set of arguments for constructing a NexusBlobstoreAzure resource.
        :param pulumi.Input['NexusBlobstoreAzureBucketConfigurationArgs'] bucket_configuration: The Azure specific configuration details for the Azure object that'll contain the blob store
        :param pulumi.Input[str] name: Blobstore name
        :param pulumi.Input['NexusBlobstoreAzureSoftQuotaArgs'] soft_quota: Soft quota of the blobstore
        """
        pulumi.set(__self__, "bucket_configuration", bucket_configuration)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if soft_quota is not None:
            pulumi.set(__self__, "soft_quota", soft_quota)

    @property
    @pulumi.getter(name="bucketConfiguration")
    def bucket_configuration(self) -> pulumi.Input['NexusBlobstoreAzureBucketConfigurationArgs']:
        """
        The Azure specific configuration details for the Azure object that'll contain the blob store
        """
        return pulumi.get(self, "bucket_configuration")

    @bucket_configuration.setter
    def bucket_configuration(self, value: pulumi.Input['NexusBlobstoreAzureBucketConfigurationArgs']):
        pulumi.set(self, "bucket_configuration", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Blobstore name
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="softQuota")
    def soft_quota(self) -> Optional[pulumi.Input['NexusBlobstoreAzureSoftQuotaArgs']]:
        """
        Soft quota of the blobstore
        """
        return pulumi.get(self, "soft_quota")

    @soft_quota.setter
    def soft_quota(self, value: Optional[pulumi.Input['NexusBlobstoreAzureSoftQuotaArgs']]):
        pulumi.set(self, "soft_quota", value)


@pulumi.input_type
class _NexusBlobstoreAzureState:
    def __init__(__self__, *,
                 blob_count: Optional[pulumi.Input[int]] = None,
                 bucket_configuration: Optional[pulumi.Input['NexusBlobstoreAzureBucketConfigurationArgs']] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 soft_quota: Optional[pulumi.Input['NexusBlobstoreAzureSoftQuotaArgs']] = None,
                 total_size_in_bytes: Optional[pulumi.Input[int]] = None):
        """
        Input properties used for looking up and filtering NexusBlobstoreAzure resources.
        :param pulumi.Input[int] blob_count: Count of blobs
        :param pulumi.Input['NexusBlobstoreAzureBucketConfigurationArgs'] bucket_configuration: The Azure specific configuration details for the Azure object that'll contain the blob store
        :param pulumi.Input[str] name: Blobstore name
        :param pulumi.Input['NexusBlobstoreAzureSoftQuotaArgs'] soft_quota: Soft quota of the blobstore
        :param pulumi.Input[int] total_size_in_bytes: The total size of the blobstore in Bytes
        """
        if blob_count is not None:
            pulumi.set(__self__, "blob_count", blob_count)
        if bucket_configuration is not None:
            pulumi.set(__self__, "bucket_configuration", bucket_configuration)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if soft_quota is not None:
            pulumi.set(__self__, "soft_quota", soft_quota)
        if total_size_in_bytes is not None:
            pulumi.set(__self__, "total_size_in_bytes", total_size_in_bytes)

    @property
    @pulumi.getter(name="blobCount")
    def blob_count(self) -> Optional[pulumi.Input[int]]:
        """
        Count of blobs
        """
        return pulumi.get(self, "blob_count")

    @blob_count.setter
    def blob_count(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "blob_count", value)

    @property
    @pulumi.getter(name="bucketConfiguration")
    def bucket_configuration(self) -> Optional[pulumi.Input['NexusBlobstoreAzureBucketConfigurationArgs']]:
        """
        The Azure specific configuration details for the Azure object that'll contain the blob store
        """
        return pulumi.get(self, "bucket_configuration")

    @bucket_configuration.setter
    def bucket_configuration(self, value: Optional[pulumi.Input['NexusBlobstoreAzureBucketConfigurationArgs']]):
        pulumi.set(self, "bucket_configuration", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Blobstore name
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="softQuota")
    def soft_quota(self) -> Optional[pulumi.Input['NexusBlobstoreAzureSoftQuotaArgs']]:
        """
        Soft quota of the blobstore
        """
        return pulumi.get(self, "soft_quota")

    @soft_quota.setter
    def soft_quota(self, value: Optional[pulumi.Input['NexusBlobstoreAzureSoftQuotaArgs']]):
        pulumi.set(self, "soft_quota", value)

    @property
    @pulumi.getter(name="totalSizeInBytes")
    def total_size_in_bytes(self) -> Optional[pulumi.Input[int]]:
        """
        The total size of the blobstore in Bytes
        """
        return pulumi.get(self, "total_size_in_bytes")

    @total_size_in_bytes.setter
    def total_size_in_bytes(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "total_size_in_bytes", value)


class NexusBlobstoreAzure(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 bucket_configuration: Optional[pulumi.Input[pulumi.InputType['NexusBlobstoreAzureBucketConfigurationArgs']]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 soft_quota: Optional[pulumi.Input[pulumi.InputType['NexusBlobstoreAzureSoftQuotaArgs']]] = None,
                 __props__=None):
        """
        Create a NexusBlobstoreAzure resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[pulumi.InputType['NexusBlobstoreAzureBucketConfigurationArgs']] bucket_configuration: The Azure specific configuration details for the Azure object that'll contain the blob store
        :param pulumi.Input[str] name: Blobstore name
        :param pulumi.Input[pulumi.InputType['NexusBlobstoreAzureSoftQuotaArgs']] soft_quota: Soft quota of the blobstore
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: NexusBlobstoreAzureArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a NexusBlobstoreAzure resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param NexusBlobstoreAzureArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(NexusBlobstoreAzureArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 bucket_configuration: Optional[pulumi.Input[pulumi.InputType['NexusBlobstoreAzureBucketConfigurationArgs']]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 soft_quota: Optional[pulumi.Input[pulumi.InputType['NexusBlobstoreAzureSoftQuotaArgs']]] = None,
                 __props__=None):
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = NexusBlobstoreAzureArgs.__new__(NexusBlobstoreAzureArgs)

            if bucket_configuration is None and not opts.urn:
                raise TypeError("Missing required property 'bucket_configuration'")
            __props__.__dict__["bucket_configuration"] = bucket_configuration
            __props__.__dict__["name"] = name
            __props__.__dict__["soft_quota"] = soft_quota
            __props__.__dict__["blob_count"] = None
            __props__.__dict__["total_size_in_bytes"] = None
        super(NexusBlobstoreAzure, __self__).__init__(
            'nexus:index/nexusBlobstoreAzure:NexusBlobstoreAzure',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            blob_count: Optional[pulumi.Input[int]] = None,
            bucket_configuration: Optional[pulumi.Input[pulumi.InputType['NexusBlobstoreAzureBucketConfigurationArgs']]] = None,
            name: Optional[pulumi.Input[str]] = None,
            soft_quota: Optional[pulumi.Input[pulumi.InputType['NexusBlobstoreAzureSoftQuotaArgs']]] = None,
            total_size_in_bytes: Optional[pulumi.Input[int]] = None) -> 'NexusBlobstoreAzure':
        """
        Get an existing NexusBlobstoreAzure resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[int] blob_count: Count of blobs
        :param pulumi.Input[pulumi.InputType['NexusBlobstoreAzureBucketConfigurationArgs']] bucket_configuration: The Azure specific configuration details for the Azure object that'll contain the blob store
        :param pulumi.Input[str] name: Blobstore name
        :param pulumi.Input[pulumi.InputType['NexusBlobstoreAzureSoftQuotaArgs']] soft_quota: Soft quota of the blobstore
        :param pulumi.Input[int] total_size_in_bytes: The total size of the blobstore in Bytes
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _NexusBlobstoreAzureState.__new__(_NexusBlobstoreAzureState)

        __props__.__dict__["blob_count"] = blob_count
        __props__.__dict__["bucket_configuration"] = bucket_configuration
        __props__.__dict__["name"] = name
        __props__.__dict__["soft_quota"] = soft_quota
        __props__.__dict__["total_size_in_bytes"] = total_size_in_bytes
        return NexusBlobstoreAzure(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="blobCount")
    def blob_count(self) -> pulumi.Output[int]:
        """
        Count of blobs
        """
        return pulumi.get(self, "blob_count")

    @property
    @pulumi.getter(name="bucketConfiguration")
    def bucket_configuration(self) -> pulumi.Output['outputs.NexusBlobstoreAzureBucketConfiguration']:
        """
        The Azure specific configuration details for the Azure object that'll contain the blob store
        """
        return pulumi.get(self, "bucket_configuration")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        Blobstore name
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="softQuota")
    def soft_quota(self) -> pulumi.Output[Optional['outputs.NexusBlobstoreAzureSoftQuota']]:
        """
        Soft quota of the blobstore
        """
        return pulumi.get(self, "soft_quota")

    @property
    @pulumi.getter(name="totalSizeInBytes")
    def total_size_in_bytes(self) -> pulumi.Output[int]:
        """
        The total size of the blobstore in Bytes
        """
        return pulumi.get(self, "total_size_in_bytes")

