# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['NexusRepositoryAptHostedArgs', 'NexusRepositoryAptHosted']

@pulumi.input_type
class NexusRepositoryAptHostedArgs:
    def __init__(__self__, *,
                 distribution: pulumi.Input[str],
                 signing: pulumi.Input['NexusRepositoryAptHostedSigningArgs'],
                 storage: pulumi.Input['NexusRepositoryAptHostedStorageArgs'],
                 cleanups: Optional[pulumi.Input[Sequence[pulumi.Input['NexusRepositoryAptHostedCleanupArgs']]]] = None,
                 component: Optional[pulumi.Input['NexusRepositoryAptHostedComponentArgs']] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 online: Optional[pulumi.Input[bool]] = None):
        """
        The set of arguments for constructing a NexusRepositoryAptHosted resource.
        :param pulumi.Input[str] distribution: Distribution to fetch
        :param pulumi.Input['NexusRepositoryAptHostedSigningArgs'] signing: Signing contains signing data of hosted repositores of format Apt
        :param pulumi.Input['NexusRepositoryAptHostedStorageArgs'] storage: The storage configuration of the repository
        :param pulumi.Input[Sequence[pulumi.Input['NexusRepositoryAptHostedCleanupArgs']]] cleanups: Cleanup policies
        :param pulumi.Input['NexusRepositoryAptHostedComponentArgs'] component: Component configuration for the hosted repository
        :param pulumi.Input[str] name: A unique identifier for this repository
        :param pulumi.Input[bool] online: Whether this repository accepts incoming requests
        """
        pulumi.set(__self__, "distribution", distribution)
        pulumi.set(__self__, "signing", signing)
        pulumi.set(__self__, "storage", storage)
        if cleanups is not None:
            pulumi.set(__self__, "cleanups", cleanups)
        if component is not None:
            pulumi.set(__self__, "component", component)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if online is not None:
            pulumi.set(__self__, "online", online)

    @property
    @pulumi.getter
    def distribution(self) -> pulumi.Input[str]:
        """
        Distribution to fetch
        """
        return pulumi.get(self, "distribution")

    @distribution.setter
    def distribution(self, value: pulumi.Input[str]):
        pulumi.set(self, "distribution", value)

    @property
    @pulumi.getter
    def signing(self) -> pulumi.Input['NexusRepositoryAptHostedSigningArgs']:
        """
        Signing contains signing data of hosted repositores of format Apt
        """
        return pulumi.get(self, "signing")

    @signing.setter
    def signing(self, value: pulumi.Input['NexusRepositoryAptHostedSigningArgs']):
        pulumi.set(self, "signing", value)

    @property
    @pulumi.getter
    def storage(self) -> pulumi.Input['NexusRepositoryAptHostedStorageArgs']:
        """
        The storage configuration of the repository
        """
        return pulumi.get(self, "storage")

    @storage.setter
    def storage(self, value: pulumi.Input['NexusRepositoryAptHostedStorageArgs']):
        pulumi.set(self, "storage", value)

    @property
    @pulumi.getter
    def cleanups(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['NexusRepositoryAptHostedCleanupArgs']]]]:
        """
        Cleanup policies
        """
        return pulumi.get(self, "cleanups")

    @cleanups.setter
    def cleanups(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['NexusRepositoryAptHostedCleanupArgs']]]]):
        pulumi.set(self, "cleanups", value)

    @property
    @pulumi.getter
    def component(self) -> Optional[pulumi.Input['NexusRepositoryAptHostedComponentArgs']]:
        """
        Component configuration for the hosted repository
        """
        return pulumi.get(self, "component")

    @component.setter
    def component(self, value: Optional[pulumi.Input['NexusRepositoryAptHostedComponentArgs']]):
        pulumi.set(self, "component", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        A unique identifier for this repository
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def online(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether this repository accepts incoming requests
        """
        return pulumi.get(self, "online")

    @online.setter
    def online(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "online", value)


@pulumi.input_type
class _NexusRepositoryAptHostedState:
    def __init__(__self__, *,
                 cleanups: Optional[pulumi.Input[Sequence[pulumi.Input['NexusRepositoryAptHostedCleanupArgs']]]] = None,
                 component: Optional[pulumi.Input['NexusRepositoryAptHostedComponentArgs']] = None,
                 distribution: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 online: Optional[pulumi.Input[bool]] = None,
                 signing: Optional[pulumi.Input['NexusRepositoryAptHostedSigningArgs']] = None,
                 storage: Optional[pulumi.Input['NexusRepositoryAptHostedStorageArgs']] = None):
        """
        Input properties used for looking up and filtering NexusRepositoryAptHosted resources.
        :param pulumi.Input[Sequence[pulumi.Input['NexusRepositoryAptHostedCleanupArgs']]] cleanups: Cleanup policies
        :param pulumi.Input['NexusRepositoryAptHostedComponentArgs'] component: Component configuration for the hosted repository
        :param pulumi.Input[str] distribution: Distribution to fetch
        :param pulumi.Input[str] name: A unique identifier for this repository
        :param pulumi.Input[bool] online: Whether this repository accepts incoming requests
        :param pulumi.Input['NexusRepositoryAptHostedSigningArgs'] signing: Signing contains signing data of hosted repositores of format Apt
        :param pulumi.Input['NexusRepositoryAptHostedStorageArgs'] storage: The storage configuration of the repository
        """
        if cleanups is not None:
            pulumi.set(__self__, "cleanups", cleanups)
        if component is not None:
            pulumi.set(__self__, "component", component)
        if distribution is not None:
            pulumi.set(__self__, "distribution", distribution)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if online is not None:
            pulumi.set(__self__, "online", online)
        if signing is not None:
            pulumi.set(__self__, "signing", signing)
        if storage is not None:
            pulumi.set(__self__, "storage", storage)

    @property
    @pulumi.getter
    def cleanups(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['NexusRepositoryAptHostedCleanupArgs']]]]:
        """
        Cleanup policies
        """
        return pulumi.get(self, "cleanups")

    @cleanups.setter
    def cleanups(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['NexusRepositoryAptHostedCleanupArgs']]]]):
        pulumi.set(self, "cleanups", value)

    @property
    @pulumi.getter
    def component(self) -> Optional[pulumi.Input['NexusRepositoryAptHostedComponentArgs']]:
        """
        Component configuration for the hosted repository
        """
        return pulumi.get(self, "component")

    @component.setter
    def component(self, value: Optional[pulumi.Input['NexusRepositoryAptHostedComponentArgs']]):
        pulumi.set(self, "component", value)

    @property
    @pulumi.getter
    def distribution(self) -> Optional[pulumi.Input[str]]:
        """
        Distribution to fetch
        """
        return pulumi.get(self, "distribution")

    @distribution.setter
    def distribution(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "distribution", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        A unique identifier for this repository
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def online(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether this repository accepts incoming requests
        """
        return pulumi.get(self, "online")

    @online.setter
    def online(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "online", value)

    @property
    @pulumi.getter
    def signing(self) -> Optional[pulumi.Input['NexusRepositoryAptHostedSigningArgs']]:
        """
        Signing contains signing data of hosted repositores of format Apt
        """
        return pulumi.get(self, "signing")

    @signing.setter
    def signing(self, value: Optional[pulumi.Input['NexusRepositoryAptHostedSigningArgs']]):
        pulumi.set(self, "signing", value)

    @property
    @pulumi.getter
    def storage(self) -> Optional[pulumi.Input['NexusRepositoryAptHostedStorageArgs']]:
        """
        The storage configuration of the repository
        """
        return pulumi.get(self, "storage")

    @storage.setter
    def storage(self, value: Optional[pulumi.Input['NexusRepositoryAptHostedStorageArgs']]):
        pulumi.set(self, "storage", value)


class NexusRepositoryAptHosted(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 cleanups: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['NexusRepositoryAptHostedCleanupArgs']]]]] = None,
                 component: Optional[pulumi.Input[pulumi.InputType['NexusRepositoryAptHostedComponentArgs']]] = None,
                 distribution: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 online: Optional[pulumi.Input[bool]] = None,
                 signing: Optional[pulumi.Input[pulumi.InputType['NexusRepositoryAptHostedSigningArgs']]] = None,
                 storage: Optional[pulumi.Input[pulumi.InputType['NexusRepositoryAptHostedStorageArgs']]] = None,
                 __props__=None):
        """
        Create a NexusRepositoryAptHosted resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['NexusRepositoryAptHostedCleanupArgs']]]] cleanups: Cleanup policies
        :param pulumi.Input[pulumi.InputType['NexusRepositoryAptHostedComponentArgs']] component: Component configuration for the hosted repository
        :param pulumi.Input[str] distribution: Distribution to fetch
        :param pulumi.Input[str] name: A unique identifier for this repository
        :param pulumi.Input[bool] online: Whether this repository accepts incoming requests
        :param pulumi.Input[pulumi.InputType['NexusRepositoryAptHostedSigningArgs']] signing: Signing contains signing data of hosted repositores of format Apt
        :param pulumi.Input[pulumi.InputType['NexusRepositoryAptHostedStorageArgs']] storage: The storage configuration of the repository
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: NexusRepositoryAptHostedArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a NexusRepositoryAptHosted resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param NexusRepositoryAptHostedArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(NexusRepositoryAptHostedArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 cleanups: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['NexusRepositoryAptHostedCleanupArgs']]]]] = None,
                 component: Optional[pulumi.Input[pulumi.InputType['NexusRepositoryAptHostedComponentArgs']]] = None,
                 distribution: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 online: Optional[pulumi.Input[bool]] = None,
                 signing: Optional[pulumi.Input[pulumi.InputType['NexusRepositoryAptHostedSigningArgs']]] = None,
                 storage: Optional[pulumi.Input[pulumi.InputType['NexusRepositoryAptHostedStorageArgs']]] = None,
                 __props__=None):
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = NexusRepositoryAptHostedArgs.__new__(NexusRepositoryAptHostedArgs)

            __props__.__dict__["cleanups"] = cleanups
            __props__.__dict__["component"] = component
            if distribution is None and not opts.urn:
                raise TypeError("Missing required property 'distribution'")
            __props__.__dict__["distribution"] = distribution
            __props__.__dict__["name"] = name
            __props__.__dict__["online"] = online
            if signing is None and not opts.urn:
                raise TypeError("Missing required property 'signing'")
            __props__.__dict__["signing"] = signing
            if storage is None and not opts.urn:
                raise TypeError("Missing required property 'storage'")
            __props__.__dict__["storage"] = storage
        super(NexusRepositoryAptHosted, __self__).__init__(
            'nexus:index/nexusRepositoryAptHosted:NexusRepositoryAptHosted',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            cleanups: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['NexusRepositoryAptHostedCleanupArgs']]]]] = None,
            component: Optional[pulumi.Input[pulumi.InputType['NexusRepositoryAptHostedComponentArgs']]] = None,
            distribution: Optional[pulumi.Input[str]] = None,
            name: Optional[pulumi.Input[str]] = None,
            online: Optional[pulumi.Input[bool]] = None,
            signing: Optional[pulumi.Input[pulumi.InputType['NexusRepositoryAptHostedSigningArgs']]] = None,
            storage: Optional[pulumi.Input[pulumi.InputType['NexusRepositoryAptHostedStorageArgs']]] = None) -> 'NexusRepositoryAptHosted':
        """
        Get an existing NexusRepositoryAptHosted resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['NexusRepositoryAptHostedCleanupArgs']]]] cleanups: Cleanup policies
        :param pulumi.Input[pulumi.InputType['NexusRepositoryAptHostedComponentArgs']] component: Component configuration for the hosted repository
        :param pulumi.Input[str] distribution: Distribution to fetch
        :param pulumi.Input[str] name: A unique identifier for this repository
        :param pulumi.Input[bool] online: Whether this repository accepts incoming requests
        :param pulumi.Input[pulumi.InputType['NexusRepositoryAptHostedSigningArgs']] signing: Signing contains signing data of hosted repositores of format Apt
        :param pulumi.Input[pulumi.InputType['NexusRepositoryAptHostedStorageArgs']] storage: The storage configuration of the repository
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _NexusRepositoryAptHostedState.__new__(_NexusRepositoryAptHostedState)

        __props__.__dict__["cleanups"] = cleanups
        __props__.__dict__["component"] = component
        __props__.__dict__["distribution"] = distribution
        __props__.__dict__["name"] = name
        __props__.__dict__["online"] = online
        __props__.__dict__["signing"] = signing
        __props__.__dict__["storage"] = storage
        return NexusRepositoryAptHosted(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def cleanups(self) -> pulumi.Output[Optional[Sequence['outputs.NexusRepositoryAptHostedCleanup']]]:
        """
        Cleanup policies
        """
        return pulumi.get(self, "cleanups")

    @property
    @pulumi.getter
    def component(self) -> pulumi.Output['outputs.NexusRepositoryAptHostedComponent']:
        """
        Component configuration for the hosted repository
        """
        return pulumi.get(self, "component")

    @property
    @pulumi.getter
    def distribution(self) -> pulumi.Output[str]:
        """
        Distribution to fetch
        """
        return pulumi.get(self, "distribution")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        A unique identifier for this repository
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def online(self) -> pulumi.Output[Optional[bool]]:
        """
        Whether this repository accepts incoming requests
        """
        return pulumi.get(self, "online")

    @property
    @pulumi.getter
    def signing(self) -> pulumi.Output['outputs.NexusRepositoryAptHostedSigning']:
        """
        Signing contains signing data of hosted repositores of format Apt
        """
        return pulumi.get(self, "signing")

    @property
    @pulumi.getter
    def storage(self) -> pulumi.Output['outputs.NexusRepositoryAptHostedStorage']:
        """
        The storage configuration of the repository
        """
        return pulumi.get(self, "storage")

