# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['NexusRepositoryMavenHostedArgs', 'NexusRepositoryMavenHosted']

@pulumi.input_type
class NexusRepositoryMavenHostedArgs:
    def __init__(__self__, *,
                 maven: pulumi.Input['NexusRepositoryMavenHostedMavenArgs'],
                 storage: pulumi.Input['NexusRepositoryMavenHostedStorageArgs'],
                 cleanups: Optional[pulumi.Input[Sequence[pulumi.Input['NexusRepositoryMavenHostedCleanupArgs']]]] = None,
                 component: Optional[pulumi.Input['NexusRepositoryMavenHostedComponentArgs']] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 online: Optional[pulumi.Input[bool]] = None):
        """
        The set of arguments for constructing a NexusRepositoryMavenHosted resource.
        :param pulumi.Input['NexusRepositoryMavenHostedMavenArgs'] maven: Maven contains additional data of maven repository
        :param pulumi.Input['NexusRepositoryMavenHostedStorageArgs'] storage: The storage configuration of the repository
        :param pulumi.Input[Sequence[pulumi.Input['NexusRepositoryMavenHostedCleanupArgs']]] cleanups: Cleanup policies
        :param pulumi.Input['NexusRepositoryMavenHostedComponentArgs'] component: Component configuration for the hosted repository
        :param pulumi.Input[str] name: A unique identifier for this repository
        :param pulumi.Input[bool] online: Whether this repository accepts incoming requests
        """
        pulumi.set(__self__, "maven", maven)
        pulumi.set(__self__, "storage", storage)
        if cleanups is not None:
            pulumi.set(__self__, "cleanups", cleanups)
        if component is not None:
            pulumi.set(__self__, "component", component)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if online is not None:
            pulumi.set(__self__, "online", online)

    @property
    @pulumi.getter
    def maven(self) -> pulumi.Input['NexusRepositoryMavenHostedMavenArgs']:
        """
        Maven contains additional data of maven repository
        """
        return pulumi.get(self, "maven")

    @maven.setter
    def maven(self, value: pulumi.Input['NexusRepositoryMavenHostedMavenArgs']):
        pulumi.set(self, "maven", value)

    @property
    @pulumi.getter
    def storage(self) -> pulumi.Input['NexusRepositoryMavenHostedStorageArgs']:
        """
        The storage configuration of the repository
        """
        return pulumi.get(self, "storage")

    @storage.setter
    def storage(self, value: pulumi.Input['NexusRepositoryMavenHostedStorageArgs']):
        pulumi.set(self, "storage", value)

    @property
    @pulumi.getter
    def cleanups(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['NexusRepositoryMavenHostedCleanupArgs']]]]:
        """
        Cleanup policies
        """
        return pulumi.get(self, "cleanups")

    @cleanups.setter
    def cleanups(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['NexusRepositoryMavenHostedCleanupArgs']]]]):
        pulumi.set(self, "cleanups", value)

    @property
    @pulumi.getter
    def component(self) -> Optional[pulumi.Input['NexusRepositoryMavenHostedComponentArgs']]:
        """
        Component configuration for the hosted repository
        """
        return pulumi.get(self, "component")

    @component.setter
    def component(self, value: Optional[pulumi.Input['NexusRepositoryMavenHostedComponentArgs']]):
        pulumi.set(self, "component", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        A unique identifier for this repository
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def online(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether this repository accepts incoming requests
        """
        return pulumi.get(self, "online")

    @online.setter
    def online(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "online", value)


@pulumi.input_type
class _NexusRepositoryMavenHostedState:
    def __init__(__self__, *,
                 cleanups: Optional[pulumi.Input[Sequence[pulumi.Input['NexusRepositoryMavenHostedCleanupArgs']]]] = None,
                 component: Optional[pulumi.Input['NexusRepositoryMavenHostedComponentArgs']] = None,
                 maven: Optional[pulumi.Input['NexusRepositoryMavenHostedMavenArgs']] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 online: Optional[pulumi.Input[bool]] = None,
                 storage: Optional[pulumi.Input['NexusRepositoryMavenHostedStorageArgs']] = None):
        """
        Input properties used for looking up and filtering NexusRepositoryMavenHosted resources.
        :param pulumi.Input[Sequence[pulumi.Input['NexusRepositoryMavenHostedCleanupArgs']]] cleanups: Cleanup policies
        :param pulumi.Input['NexusRepositoryMavenHostedComponentArgs'] component: Component configuration for the hosted repository
        :param pulumi.Input['NexusRepositoryMavenHostedMavenArgs'] maven: Maven contains additional data of maven repository
        :param pulumi.Input[str] name: A unique identifier for this repository
        :param pulumi.Input[bool] online: Whether this repository accepts incoming requests
        :param pulumi.Input['NexusRepositoryMavenHostedStorageArgs'] storage: The storage configuration of the repository
        """
        if cleanups is not None:
            pulumi.set(__self__, "cleanups", cleanups)
        if component is not None:
            pulumi.set(__self__, "component", component)
        if maven is not None:
            pulumi.set(__self__, "maven", maven)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if online is not None:
            pulumi.set(__self__, "online", online)
        if storage is not None:
            pulumi.set(__self__, "storage", storage)

    @property
    @pulumi.getter
    def cleanups(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['NexusRepositoryMavenHostedCleanupArgs']]]]:
        """
        Cleanup policies
        """
        return pulumi.get(self, "cleanups")

    @cleanups.setter
    def cleanups(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['NexusRepositoryMavenHostedCleanupArgs']]]]):
        pulumi.set(self, "cleanups", value)

    @property
    @pulumi.getter
    def component(self) -> Optional[pulumi.Input['NexusRepositoryMavenHostedComponentArgs']]:
        """
        Component configuration for the hosted repository
        """
        return pulumi.get(self, "component")

    @component.setter
    def component(self, value: Optional[pulumi.Input['NexusRepositoryMavenHostedComponentArgs']]):
        pulumi.set(self, "component", value)

    @property
    @pulumi.getter
    def maven(self) -> Optional[pulumi.Input['NexusRepositoryMavenHostedMavenArgs']]:
        """
        Maven contains additional data of maven repository
        """
        return pulumi.get(self, "maven")

    @maven.setter
    def maven(self, value: Optional[pulumi.Input['NexusRepositoryMavenHostedMavenArgs']]):
        pulumi.set(self, "maven", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        A unique identifier for this repository
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def online(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether this repository accepts incoming requests
        """
        return pulumi.get(self, "online")

    @online.setter
    def online(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "online", value)

    @property
    @pulumi.getter
    def storage(self) -> Optional[pulumi.Input['NexusRepositoryMavenHostedStorageArgs']]:
        """
        The storage configuration of the repository
        """
        return pulumi.get(self, "storage")

    @storage.setter
    def storage(self, value: Optional[pulumi.Input['NexusRepositoryMavenHostedStorageArgs']]):
        pulumi.set(self, "storage", value)


class NexusRepositoryMavenHosted(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 cleanups: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['NexusRepositoryMavenHostedCleanupArgs']]]]] = None,
                 component: Optional[pulumi.Input[pulumi.InputType['NexusRepositoryMavenHostedComponentArgs']]] = None,
                 maven: Optional[pulumi.Input[pulumi.InputType['NexusRepositoryMavenHostedMavenArgs']]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 online: Optional[pulumi.Input[bool]] = None,
                 storage: Optional[pulumi.Input[pulumi.InputType['NexusRepositoryMavenHostedStorageArgs']]] = None,
                 __props__=None):
        """
        Create a NexusRepositoryMavenHosted resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['NexusRepositoryMavenHostedCleanupArgs']]]] cleanups: Cleanup policies
        :param pulumi.Input[pulumi.InputType['NexusRepositoryMavenHostedComponentArgs']] component: Component configuration for the hosted repository
        :param pulumi.Input[pulumi.InputType['NexusRepositoryMavenHostedMavenArgs']] maven: Maven contains additional data of maven repository
        :param pulumi.Input[str] name: A unique identifier for this repository
        :param pulumi.Input[bool] online: Whether this repository accepts incoming requests
        :param pulumi.Input[pulumi.InputType['NexusRepositoryMavenHostedStorageArgs']] storage: The storage configuration of the repository
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: NexusRepositoryMavenHostedArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a NexusRepositoryMavenHosted resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param NexusRepositoryMavenHostedArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(NexusRepositoryMavenHostedArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 cleanups: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['NexusRepositoryMavenHostedCleanupArgs']]]]] = None,
                 component: Optional[pulumi.Input[pulumi.InputType['NexusRepositoryMavenHostedComponentArgs']]] = None,
                 maven: Optional[pulumi.Input[pulumi.InputType['NexusRepositoryMavenHostedMavenArgs']]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 online: Optional[pulumi.Input[bool]] = None,
                 storage: Optional[pulumi.Input[pulumi.InputType['NexusRepositoryMavenHostedStorageArgs']]] = None,
                 __props__=None):
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = NexusRepositoryMavenHostedArgs.__new__(NexusRepositoryMavenHostedArgs)

            __props__.__dict__["cleanups"] = cleanups
            __props__.__dict__["component"] = component
            if maven is None and not opts.urn:
                raise TypeError("Missing required property 'maven'")
            __props__.__dict__["maven"] = maven
            __props__.__dict__["name"] = name
            __props__.__dict__["online"] = online
            if storage is None and not opts.urn:
                raise TypeError("Missing required property 'storage'")
            __props__.__dict__["storage"] = storage
        super(NexusRepositoryMavenHosted, __self__).__init__(
            'nexus:index/nexusRepositoryMavenHosted:NexusRepositoryMavenHosted',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            cleanups: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['NexusRepositoryMavenHostedCleanupArgs']]]]] = None,
            component: Optional[pulumi.Input[pulumi.InputType['NexusRepositoryMavenHostedComponentArgs']]] = None,
            maven: Optional[pulumi.Input[pulumi.InputType['NexusRepositoryMavenHostedMavenArgs']]] = None,
            name: Optional[pulumi.Input[str]] = None,
            online: Optional[pulumi.Input[bool]] = None,
            storage: Optional[pulumi.Input[pulumi.InputType['NexusRepositoryMavenHostedStorageArgs']]] = None) -> 'NexusRepositoryMavenHosted':
        """
        Get an existing NexusRepositoryMavenHosted resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['NexusRepositoryMavenHostedCleanupArgs']]]] cleanups: Cleanup policies
        :param pulumi.Input[pulumi.InputType['NexusRepositoryMavenHostedComponentArgs']] component: Component configuration for the hosted repository
        :param pulumi.Input[pulumi.InputType['NexusRepositoryMavenHostedMavenArgs']] maven: Maven contains additional data of maven repository
        :param pulumi.Input[str] name: A unique identifier for this repository
        :param pulumi.Input[bool] online: Whether this repository accepts incoming requests
        :param pulumi.Input[pulumi.InputType['NexusRepositoryMavenHostedStorageArgs']] storage: The storage configuration of the repository
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _NexusRepositoryMavenHostedState.__new__(_NexusRepositoryMavenHostedState)

        __props__.__dict__["cleanups"] = cleanups
        __props__.__dict__["component"] = component
        __props__.__dict__["maven"] = maven
        __props__.__dict__["name"] = name
        __props__.__dict__["online"] = online
        __props__.__dict__["storage"] = storage
        return NexusRepositoryMavenHosted(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def cleanups(self) -> pulumi.Output[Optional[Sequence['outputs.NexusRepositoryMavenHostedCleanup']]]:
        """
        Cleanup policies
        """
        return pulumi.get(self, "cleanups")

    @property
    @pulumi.getter
    def component(self) -> pulumi.Output['outputs.NexusRepositoryMavenHostedComponent']:
        """
        Component configuration for the hosted repository
        """
        return pulumi.get(self, "component")

    @property
    @pulumi.getter
    def maven(self) -> pulumi.Output['outputs.NexusRepositoryMavenHostedMaven']:
        """
        Maven contains additional data of maven repository
        """
        return pulumi.get(self, "maven")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        A unique identifier for this repository
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def online(self) -> pulumi.Output[Optional[bool]]:
        """
        Whether this repository accepts incoming requests
        """
        return pulumi.get(self, "online")

    @property
    @pulumi.getter
    def storage(self) -> pulumi.Output['outputs.NexusRepositoryMavenHostedStorage']:
        """
        The storage configuration of the repository
        """
        return pulumi.get(self, "storage")

