# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['NexusRepositoryYumHostedArgs', 'NexusRepositoryYumHosted']

@pulumi.input_type
class NexusRepositoryYumHostedArgs:
    def __init__(__self__, *,
                 storage: pulumi.Input['NexusRepositoryYumHostedStorageArgs'],
                 cleanups: Optional[pulumi.Input[Sequence[pulumi.Input['NexusRepositoryYumHostedCleanupArgs']]]] = None,
                 component: Optional[pulumi.Input['NexusRepositoryYumHostedComponentArgs']] = None,
                 deploy_policy: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 online: Optional[pulumi.Input[bool]] = None,
                 repodata_depth: Optional[pulumi.Input[int]] = None):
        """
        The set of arguments for constructing a NexusRepositoryYumHosted resource.
        :param pulumi.Input['NexusRepositoryYumHostedStorageArgs'] storage: The storage configuration of the repository
        :param pulumi.Input[Sequence[pulumi.Input['NexusRepositoryYumHostedCleanupArgs']]] cleanups: Cleanup policies
        :param pulumi.Input['NexusRepositoryYumHostedComponentArgs'] component: Component configuration for the hosted repository
        :param pulumi.Input[str] deploy_policy: Validate that all paths are RPMs or yum metadata. Possible values: `STRICT` or `PERMISSIVE`
        :param pulumi.Input[str] name: A unique identifier for this repository
        :param pulumi.Input[bool] online: Whether this repository accepts incoming requests
        :param pulumi.Input[int] repodata_depth: Specifies the repository depth where repodata folder(s) are created. Possible values: 0-5
        """
        pulumi.set(__self__, "storage", storage)
        if cleanups is not None:
            pulumi.set(__self__, "cleanups", cleanups)
        if component is not None:
            pulumi.set(__self__, "component", component)
        if deploy_policy is not None:
            pulumi.set(__self__, "deploy_policy", deploy_policy)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if online is not None:
            pulumi.set(__self__, "online", online)
        if repodata_depth is not None:
            pulumi.set(__self__, "repodata_depth", repodata_depth)

    @property
    @pulumi.getter
    def storage(self) -> pulumi.Input['NexusRepositoryYumHostedStorageArgs']:
        """
        The storage configuration of the repository
        """
        return pulumi.get(self, "storage")

    @storage.setter
    def storage(self, value: pulumi.Input['NexusRepositoryYumHostedStorageArgs']):
        pulumi.set(self, "storage", value)

    @property
    @pulumi.getter
    def cleanups(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['NexusRepositoryYumHostedCleanupArgs']]]]:
        """
        Cleanup policies
        """
        return pulumi.get(self, "cleanups")

    @cleanups.setter
    def cleanups(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['NexusRepositoryYumHostedCleanupArgs']]]]):
        pulumi.set(self, "cleanups", value)

    @property
    @pulumi.getter
    def component(self) -> Optional[pulumi.Input['NexusRepositoryYumHostedComponentArgs']]:
        """
        Component configuration for the hosted repository
        """
        return pulumi.get(self, "component")

    @component.setter
    def component(self, value: Optional[pulumi.Input['NexusRepositoryYumHostedComponentArgs']]):
        pulumi.set(self, "component", value)

    @property
    @pulumi.getter(name="deployPolicy")
    def deploy_policy(self) -> Optional[pulumi.Input[str]]:
        """
        Validate that all paths are RPMs or yum metadata. Possible values: `STRICT` or `PERMISSIVE`
        """
        return pulumi.get(self, "deploy_policy")

    @deploy_policy.setter
    def deploy_policy(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "deploy_policy", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        A unique identifier for this repository
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def online(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether this repository accepts incoming requests
        """
        return pulumi.get(self, "online")

    @online.setter
    def online(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "online", value)

    @property
    @pulumi.getter(name="repodataDepth")
    def repodata_depth(self) -> Optional[pulumi.Input[int]]:
        """
        Specifies the repository depth where repodata folder(s) are created. Possible values: 0-5
        """
        return pulumi.get(self, "repodata_depth")

    @repodata_depth.setter
    def repodata_depth(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "repodata_depth", value)


@pulumi.input_type
class _NexusRepositoryYumHostedState:
    def __init__(__self__, *,
                 cleanups: Optional[pulumi.Input[Sequence[pulumi.Input['NexusRepositoryYumHostedCleanupArgs']]]] = None,
                 component: Optional[pulumi.Input['NexusRepositoryYumHostedComponentArgs']] = None,
                 deploy_policy: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 online: Optional[pulumi.Input[bool]] = None,
                 repodata_depth: Optional[pulumi.Input[int]] = None,
                 storage: Optional[pulumi.Input['NexusRepositoryYumHostedStorageArgs']] = None):
        """
        Input properties used for looking up and filtering NexusRepositoryYumHosted resources.
        :param pulumi.Input[Sequence[pulumi.Input['NexusRepositoryYumHostedCleanupArgs']]] cleanups: Cleanup policies
        :param pulumi.Input['NexusRepositoryYumHostedComponentArgs'] component: Component configuration for the hosted repository
        :param pulumi.Input[str] deploy_policy: Validate that all paths are RPMs or yum metadata. Possible values: `STRICT` or `PERMISSIVE`
        :param pulumi.Input[str] name: A unique identifier for this repository
        :param pulumi.Input[bool] online: Whether this repository accepts incoming requests
        :param pulumi.Input[int] repodata_depth: Specifies the repository depth where repodata folder(s) are created. Possible values: 0-5
        :param pulumi.Input['NexusRepositoryYumHostedStorageArgs'] storage: The storage configuration of the repository
        """
        if cleanups is not None:
            pulumi.set(__self__, "cleanups", cleanups)
        if component is not None:
            pulumi.set(__self__, "component", component)
        if deploy_policy is not None:
            pulumi.set(__self__, "deploy_policy", deploy_policy)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if online is not None:
            pulumi.set(__self__, "online", online)
        if repodata_depth is not None:
            pulumi.set(__self__, "repodata_depth", repodata_depth)
        if storage is not None:
            pulumi.set(__self__, "storage", storage)

    @property
    @pulumi.getter
    def cleanups(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['NexusRepositoryYumHostedCleanupArgs']]]]:
        """
        Cleanup policies
        """
        return pulumi.get(self, "cleanups")

    @cleanups.setter
    def cleanups(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['NexusRepositoryYumHostedCleanupArgs']]]]):
        pulumi.set(self, "cleanups", value)

    @property
    @pulumi.getter
    def component(self) -> Optional[pulumi.Input['NexusRepositoryYumHostedComponentArgs']]:
        """
        Component configuration for the hosted repository
        """
        return pulumi.get(self, "component")

    @component.setter
    def component(self, value: Optional[pulumi.Input['NexusRepositoryYumHostedComponentArgs']]):
        pulumi.set(self, "component", value)

    @property
    @pulumi.getter(name="deployPolicy")
    def deploy_policy(self) -> Optional[pulumi.Input[str]]:
        """
        Validate that all paths are RPMs or yum metadata. Possible values: `STRICT` or `PERMISSIVE`
        """
        return pulumi.get(self, "deploy_policy")

    @deploy_policy.setter
    def deploy_policy(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "deploy_policy", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        A unique identifier for this repository
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def online(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether this repository accepts incoming requests
        """
        return pulumi.get(self, "online")

    @online.setter
    def online(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "online", value)

    @property
    @pulumi.getter(name="repodataDepth")
    def repodata_depth(self) -> Optional[pulumi.Input[int]]:
        """
        Specifies the repository depth where repodata folder(s) are created. Possible values: 0-5
        """
        return pulumi.get(self, "repodata_depth")

    @repodata_depth.setter
    def repodata_depth(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "repodata_depth", value)

    @property
    @pulumi.getter
    def storage(self) -> Optional[pulumi.Input['NexusRepositoryYumHostedStorageArgs']]:
        """
        The storage configuration of the repository
        """
        return pulumi.get(self, "storage")

    @storage.setter
    def storage(self, value: Optional[pulumi.Input['NexusRepositoryYumHostedStorageArgs']]):
        pulumi.set(self, "storage", value)


class NexusRepositoryYumHosted(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 cleanups: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['NexusRepositoryYumHostedCleanupArgs']]]]] = None,
                 component: Optional[pulumi.Input[pulumi.InputType['NexusRepositoryYumHostedComponentArgs']]] = None,
                 deploy_policy: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 online: Optional[pulumi.Input[bool]] = None,
                 repodata_depth: Optional[pulumi.Input[int]] = None,
                 storage: Optional[pulumi.Input[pulumi.InputType['NexusRepositoryYumHostedStorageArgs']]] = None,
                 __props__=None):
        """
        Create a NexusRepositoryYumHosted resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['NexusRepositoryYumHostedCleanupArgs']]]] cleanups: Cleanup policies
        :param pulumi.Input[pulumi.InputType['NexusRepositoryYumHostedComponentArgs']] component: Component configuration for the hosted repository
        :param pulumi.Input[str] deploy_policy: Validate that all paths are RPMs or yum metadata. Possible values: `STRICT` or `PERMISSIVE`
        :param pulumi.Input[str] name: A unique identifier for this repository
        :param pulumi.Input[bool] online: Whether this repository accepts incoming requests
        :param pulumi.Input[int] repodata_depth: Specifies the repository depth where repodata folder(s) are created. Possible values: 0-5
        :param pulumi.Input[pulumi.InputType['NexusRepositoryYumHostedStorageArgs']] storage: The storage configuration of the repository
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: NexusRepositoryYumHostedArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a NexusRepositoryYumHosted resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param NexusRepositoryYumHostedArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(NexusRepositoryYumHostedArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 cleanups: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['NexusRepositoryYumHostedCleanupArgs']]]]] = None,
                 component: Optional[pulumi.Input[pulumi.InputType['NexusRepositoryYumHostedComponentArgs']]] = None,
                 deploy_policy: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 online: Optional[pulumi.Input[bool]] = None,
                 repodata_depth: Optional[pulumi.Input[int]] = None,
                 storage: Optional[pulumi.Input[pulumi.InputType['NexusRepositoryYumHostedStorageArgs']]] = None,
                 __props__=None):
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = NexusRepositoryYumHostedArgs.__new__(NexusRepositoryYumHostedArgs)

            __props__.__dict__["cleanups"] = cleanups
            __props__.__dict__["component"] = component
            __props__.__dict__["deploy_policy"] = deploy_policy
            __props__.__dict__["name"] = name
            __props__.__dict__["online"] = online
            __props__.__dict__["repodata_depth"] = repodata_depth
            if storage is None and not opts.urn:
                raise TypeError("Missing required property 'storage'")
            __props__.__dict__["storage"] = storage
        super(NexusRepositoryYumHosted, __self__).__init__(
            'nexus:index/nexusRepositoryYumHosted:NexusRepositoryYumHosted',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            cleanups: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['NexusRepositoryYumHostedCleanupArgs']]]]] = None,
            component: Optional[pulumi.Input[pulumi.InputType['NexusRepositoryYumHostedComponentArgs']]] = None,
            deploy_policy: Optional[pulumi.Input[str]] = None,
            name: Optional[pulumi.Input[str]] = None,
            online: Optional[pulumi.Input[bool]] = None,
            repodata_depth: Optional[pulumi.Input[int]] = None,
            storage: Optional[pulumi.Input[pulumi.InputType['NexusRepositoryYumHostedStorageArgs']]] = None) -> 'NexusRepositoryYumHosted':
        """
        Get an existing NexusRepositoryYumHosted resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['NexusRepositoryYumHostedCleanupArgs']]]] cleanups: Cleanup policies
        :param pulumi.Input[pulumi.InputType['NexusRepositoryYumHostedComponentArgs']] component: Component configuration for the hosted repository
        :param pulumi.Input[str] deploy_policy: Validate that all paths are RPMs or yum metadata. Possible values: `STRICT` or `PERMISSIVE`
        :param pulumi.Input[str] name: A unique identifier for this repository
        :param pulumi.Input[bool] online: Whether this repository accepts incoming requests
        :param pulumi.Input[int] repodata_depth: Specifies the repository depth where repodata folder(s) are created. Possible values: 0-5
        :param pulumi.Input[pulumi.InputType['NexusRepositoryYumHostedStorageArgs']] storage: The storage configuration of the repository
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _NexusRepositoryYumHostedState.__new__(_NexusRepositoryYumHostedState)

        __props__.__dict__["cleanups"] = cleanups
        __props__.__dict__["component"] = component
        __props__.__dict__["deploy_policy"] = deploy_policy
        __props__.__dict__["name"] = name
        __props__.__dict__["online"] = online
        __props__.__dict__["repodata_depth"] = repodata_depth
        __props__.__dict__["storage"] = storage
        return NexusRepositoryYumHosted(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def cleanups(self) -> pulumi.Output[Optional[Sequence['outputs.NexusRepositoryYumHostedCleanup']]]:
        """
        Cleanup policies
        """
        return pulumi.get(self, "cleanups")

    @property
    @pulumi.getter
    def component(self) -> pulumi.Output['outputs.NexusRepositoryYumHostedComponent']:
        """
        Component configuration for the hosted repository
        """
        return pulumi.get(self, "component")

    @property
    @pulumi.getter(name="deployPolicy")
    def deploy_policy(self) -> pulumi.Output[Optional[str]]:
        """
        Validate that all paths are RPMs or yum metadata. Possible values: `STRICT` or `PERMISSIVE`
        """
        return pulumi.get(self, "deploy_policy")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        A unique identifier for this repository
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def online(self) -> pulumi.Output[Optional[bool]]:
        """
        Whether this repository accepts incoming requests
        """
        return pulumi.get(self, "online")

    @property
    @pulumi.getter(name="repodataDepth")
    def repodata_depth(self) -> pulumi.Output[Optional[int]]:
        """
        Specifies the repository depth where repodata folder(s) are created. Possible values: 0-5
        """
        return pulumi.get(self, "repodata_depth")

    @property
    @pulumi.getter
    def storage(self) -> pulumi.Output['outputs.NexusRepositoryYumHostedStorage']:
        """
        The storage configuration of the repository
        """
        return pulumi.get(self, "storage")

